@--------Preliminary stuff--------------------------------------------------------@
new ,60000;
ttt = time;
ddd = date;
cls;
call sysstate(14,1e-128);
diffs = 1;
attheend = 1;
outwidth 256;
@--------Name of the output file.-------------------------------------------------@

output file = FM.txt reset;
format /rd 8,4;

@--------Set some basic parameters for the estimation.----------------------------@

numlag = 3;    /* number of dropped years because of lags, etc. */


clear dta, rawdta;
@--------Read in the excel file.--------------------------------------------------@
  dataset = "dfw110916.csv";
  dta = SpreadsheetReadM(dataset,"a2:x705",1);

@--------Set some basic parameters to describe the data.-----------------@

nyr = 32;
fyr = 1978;

   nco = rows(dta)/nyr;
@-----------This part rearranges things in cities instead of in years----------@



@------These just pick out current and lagged values.-------------------@

pickmsa  = seqa(1,1,nco);
pickyear = seqa(1,1,nyr-numlag);
pick0 = zeros(nco*(nyr-numlag),1);
pick1 = zeros(nco*(nyr-numlag),1);
pick2 = zeros(nco*(nyr-numlag),1);
pick3 = zeros(nco*(nyr-numlag),1);
for ii(1,nco,1);
   pick0[(ii-1)*(nyr-numlag)+1:ii*(nyr-numlag),1] = (ii-1)*(nyr-0) + pickyear + 3;   /* current */
   pick1[(ii-1)*(nyr-numlag)+1:ii*(nyr-numlag),1] = (ii-1)*(nyr-0) + pickyear + 2;   /* lagged once */
   pick2[(ii-1)*(nyr-numlag)+1:ii*(nyr-numlag),1] = (ii-1)*(nyr-0) + pickyear + 1;   /* lagged twice */
   pick3[(ii-1)*(nyr-numlag)+1:ii*(nyr-numlag),1] = (ii-1)*(nyr-0) + pickyear + 0;   /* lagged thrice. */
endfor;

clear c;

/* ***************************************************
 generate city level TFP
 ***************************************************
*/
    csbsa               = dta[.,1];      @ cbsa                  @
    year                = dta[.,2];      @ year                  @



    lavgwagehi_hat      = dta[.,3];      @ lavgwagehi_hat        @
    lrs2_hat            = dta[.,4];      @ lrs2_hat              @
    lplevel_hat         = dta[.,5];      @ lplevel_hat           @
    lexpshare_hat       = dta[.,6];      @ lexpshare_hat         @
    lhilorat_hat        = dta[.,7];      @ lhilorat_hat          @


    dbt_kbt             = dta[.,8];      @ dbt_kbt               @
    dst_kst             = dta[.,9];      @ dst_kst               @
    dft_kft             = dta[.,10];     @ dft_kft               @
    Erhit               = dta[.,11];     @ Erhit                 @
    pbt                 = dta[.,12];     @ pbt                   @
    pst                 = dta[.,13];     @ pst                   @
    pft                 = dta[.,14];     @ pft                   @
    landsh_h            = dta[.,15];     @ landshare_housing     @
    landsh_k            = dta[.,16];     @ landshare_buscapital  @
    labsh_o             = dta[.,17];     @ laborshare_output     @
    infrsh_l            = dta[.,18];     @ infrashare_land       @
    ct                  = dta[.,19];     @ ct                    @
    vhp                 = dta[.,20];     @ lhp                   @
    vpcy                = dta[.,21];     @ lpersinc              @
    vhp_hat             = dta[.,22];     @ lhp_hat               @
    vpcy_hat            = dta[.,23];     @ lpersinc_hat          @
    vpcy_hat            = dta[.,23];     @ lpersinc_hat          @
    pt                  = dta[.,24];     @ lpbls_pop_agg         @

phi   = 0.974;
alpha = 0.299;
xi    = 0.545;
omega = 0.668;
 tfp_hat = ((1-phi)/(1-omega))*lrs2_hat
            + (1-alpha)*phi*(lavgwagehi_hat - ((1-xi)/xi)*lexpshare_hat - (xi-1)*lhilorat_hat)
            - lplevel_hat                                                                      ;

/* ***************************************************
  generate externality term
 ***************************************************
*/
extern_hat = (1.0/(1.0-omega))*lrs2_hat - lplevel_hat;
dta = dta~tfp_hat~extern_hat;



@------------This part gets time t-0,t-1,t-2,t-3,t-4 data.-----------------------------@
      dta0 = dta[pick0,.];
      dta1 = dta[pick1,.];
      dta2 = dta[pick2,.];
      dta3 = dta[pick3,.];

    deldta0 = zeros(rows(dta0),cols(dta0));
    deldta1 = zeros(rows(dta0),cols(dta0));
    deldta2 = zeros(rows(dta0),cols(dta0));



    deldta0[.,1:2] = dta0[.,1:2];
    deldta1[.,1:2] = dta1[.,1:2];
    deldta2[.,1:2] = dta2[.,1:2];

    deldta0[.,3:cols(dta)] = dta0[.,3:cols(dta)] - dta1[.,3:cols(dta)];
    deldta1[.,3:cols(dta)] = dta1[.,3:cols(dta)] - dta2[.,3:cols(dta)];
    deldta2[.,3:cols(dta)] = dta2[.,3:cols(dta)] - dta3[.,3:cols(dta)];


    @------Define all of the variables.-----------------------------------------------@
    @------It isn't necessary to define all of them, but it is a useful check.--------@


    @------Define all of the instruments. See how everything lines up.---------------@


    if diffs == 1;
       let zidx = 3  4 5 6 7 22 23;
       allz  = deldta2[.,zidx];
    else;
       let zidx = 3 4 5 6 7 22 23;
       allz  = dta2[.,zidx];
    endif;

    numz = cols(allz);

@------------------------------------------------------------------------------------------------------@
@------------------------------------------------------------------------------------------------------@
@----------------End of the data setup. Now this is the core estimation.-------------------------------@
@------------------------------------------------------------------------------------------------------@
@------------------------------------------------------------------------------------------------------@

ally = deldta0[.,25];
allx = deldta0[.,26];


gvkeys = unique(dta0[.,1],1);
allyrs = unique(dta0[.,2],1);

OLStime = zeros(nco,1);         OLStimeI  = zeros(nyr-numlag,nco);
OLScity = zeros(nyr-numlag,1);  OLScityI  = zeros(nco,nyr-numlag);

IVtime = zeros(nco,1);          IVtimeI  = zeros(nyr-numlag,nco);
IVcity = zeros(nyr-numlag,1);   IVcityI  = zeros(nco,nyr-numlag);


/* First do the panel with clustered errors. */

       @------------OLS goes first.--------------------@

       des = allx;
       dd = invpd(des'des);
       bhat = dd*des'ally;


       uhat = ally - des*bhat;
       wh = uhat.*des;
       ww = zeros(cols(des),cols(des));

       for qq(1,nco,1);
           hi = sumc(wh[(qq-1)*(nyr-numlag)+1:qq*(nyr-numlag),.]);
           ww = ww + hi*hi';
       endfor;

       vb = (dd*(ww)*dd);

       gee = -(1-bhat)^(-2);
       bhat = 1/(1-bhat);
       seb = sqrt(diag(gee'vb*gee));

       "OLS Panel ";
       bhat~seb;

       @----------------Now do the panel 2sls stuff----------------------@
       pz = allz*invpd(allz'allz)*allz';
       zz = invpd(allx'pz*allx);
       biv = zz*allx'pz*ally;

       uhat = ally - des*biv;
       wh = uhat.*allz;
       ww = zeros(cols(allz),cols(allz));

       for qq(1,nco,1);
           hi = sumc(wh[(qq-1)*(nyr-numlag)+1:qq*(nyr-numlag),.]);
           ww = ww + hi*hi';
       endfor;

       viv = zz*(allx'allz*invpd(allz'allz)*ww*invpd(allz'allz)*allz'allx)*zz;

       gee = -(1-biv)^(-2);
       bivt = 1/(1-biv);
       siv = sqrt(diag(gee'viv*gee));

       "IV Panel ";
        biv~bivt~siv;

        @----This prints out the data for Jonas for the scatter plots.@
        forjonas = pz*allx;
        forjonas = ally~forjonas~allx;

        @---------------This does the ``trim at 0.05'' experiment--------------@

        yi = selif(forjonas[.,1],abs(forjonas[.,1]).<0.05);
        xi = selif(forjonas[.,2],abs(forjonas[.,1]).<0.05);

        "This is the slope if we hack off the bottom and top 5% ";; invpd(xi'xi)*xi'yi;







       @---This calculates the first-stage R2@
       des = allz ;
       dd = invpd(des'des);
       bhat = dd*des'allx;

       uhat = allx - des*bhat;
       r2 = 1 - moment(uhat,0)/(moment((allx - meanc(allx)),0));

       eff = r2/(cols(des)-1);
       eff = eff/((1-r2)/(rows(des)-cols(des)));

       "r-squared ";; r2;;
       "f-stat    ";; eff;



@-------------------Do the city by city stuff--------------------------@

for ii(1,nco,1);

  y = selif(ally,dta0[.,1].==gvkeys[ii,1]);
  x = selif(allx,dta0[.,1].==gvkeys[ii,1]);
  z = selif(allz,dta0[.,1].==gvkeys[ii,1]);

  bhat = invpd(x'x)*x'y;
  OLStime[ii,1] = bhat[1,1];

  uhat = y - x*bhat;
  binfl = (inv(x'x)*(x.*uhat)')';
  OLStimeI[.,ii]  = binfl[.,1];

  pz = z*invpd(z'z)*z';
  biv = invpd(x'pz*x)*x'pz*y;
  IVtime[ii,1] = biv[1,1];
  bivinfl =  (invpd(x'pz*x)*x'z*invpd(z'z)*(z.*y)')';
  IVtimeI[.,ii] = bivinfl[.,1];

  des = ones(rows(z),1)~z;
  allb = invpd(des'des)*des'x;

       uhat = x- des*allb;
       r2 = 1 - moment(uhat,0)/(moment((x - meanc(x)),0));

       eff = r2/(cols(des)-1);
       eff = eff/((1-r2)/(rows(des)-cols(des)));
        @
       "r-squared ";; r2;;
       "f-stat    ";; eff;
            @
endfor;

{ theta, stderr } = makeaverage(OLStime);
"OLS from 22 cities"; theta~stderr;

{ theta, stderr } = makeaverage(IVtime);
"2SLS from 22 cities"; theta~stderr;

@--------------------Do the time by time stuff----------------------------@

 print;

for ii(1,nyr-numlag,1);

  y = selif(ally,dta0[.,2].==allyrs[ii,1]);
  x = selif(allx,dta0[.,2].==allyrs[ii,1]);
  z = selif(allz,dta0[.,2].==allyrs[ii,1]);

  bhat = invpd(x'x)*x'y;
  OLScity[ii,1] = bhat[1,1];

  uhat = y - x*bhat;
  binfl = (inv(x'x)*(x.*uhat)')';
  OLScityI[.,ii]  = binfl[.,1];

  pz = z*invpd(z'z)*z';
  biv = invpd(x'pz*x)*x'pz*y;
  IVcity[ii,1] = biv[1,1];
  bivinfl =  (invpd(x'pz*x)*x'z*invpd(z'z)*(z.*y)')';
  IVcityI[.,ii] = bivinfl[.,1];

  des = ones(rows(z),1)~z;
  allb = invpd(des'des)*des'x;

       uhat = x- des*allb;
       r2 = 1 - moment(uhat,0)/(moment((x - meanc(x)),0));

       eff = r2/(cols(des)-1);
       eff = eff/((1-r2)/(rows(des)-cols(des)));
               @
       "r-squared ";; r2;;
       "f-stat    ";; eff;
              @


endfor;


{ theta, stderr } = makeaverage(OLScity);
"OLS from 29 years"; theta~stderr;

{ theta, stderr } = makeaverage(IVcity);
"2SLS from 29 years"; theta~stderr;



format /rd 26,16;
screen off;
forjonas;
screen on;

proc (2) = makeaverage(zee);
local theta, stderr, gee;
if attheend==0;

    theta = meanc(zee);
    stderr = moment(zee-meanc(zee),0)/(rows(zee)-0)^2;
    gee = -(1-theta)^(-2);
    theta = 1/(1-theta);
    stderr = sqrt(gee'stderr*gee);

else;

   zee = 1./(1-zee);
   theta = meanc(zee);
   stderr = moment(zee-meanc(zee),0)/(rows(zee)-0)^2;
   stderr=sqrt(stderr);

endif;
retp(theta,stderr);
endp;



end;

