/*
Notes: This is just a variant of the baseline program, but for which we lag the instruments 4 time periods

*/
@--------Preliminary stuff--------------------------------------------------------@
new ,60000;
ttt = time;
ddd = date;
cls;
call sysstate(14,1e-128);


@--------Name of the output file.-------------------------------------------------@

output file = diffinst.txt reset;
format /rd 8,3;
outwidth 256;
@--------Set some basic parameters for the estimation.----------------------------@

numlag = 5;    /* number of dropped years because of lags, etc. */
ncount = 0; /* number of bootstrap iterations */
neq = 19;      /* number of moment conditions -- not including the instrumented regressions */
nc = 21;       /* number of parameters */
houston = 1;   /* keep houston in the data set */

let cname =    /* parameter names */

kappa_b    @ 1  @
kappa_s    @ 2  @
kappa_f    @ 3  @
pb0        @ 4  @
gpb        @ 5  @
ps0        @ 6  @
gps        @ 7  @
pf0        @ 8  @
gpf        @ 9  @
omega      @10  @
alpha      @11  @
gpl        @12  @
Erh_0      @13  @
phi        @14  @
zayta      @15  @
c0         @16  @
gc         @17  @
n0         @18  @
gn         @19  @
delta      @20  @
xi;        @21  @

rlim = 20;      /* max number of times to iterate on the weight matrix. */
maxsqez=40;     /* max number of backsteps per iteration. */
maxiter=400;    /* max number of iterations to minimize the GMM objective function. */
tol=1e-12;       /* convergence criterion. */
cluster = 1;   onlyerr = 0;  /* the cluster option is obvious. onlyerr means that you use the optimal weight matrix but cluster at the end. less efficient */
diffs = 1;
nlag = 0;
doraw = 0;


clear dta, rawdta;
@--------Read in the excel file.--------------------------------------------------@
  dataset = "dfw110916.csv";
  dta = SpreadsheetReadM(dataset,"a2:x705",1);

if houston==0;
  rawdta = selif(rawdta,rawdta[.,1]./=26420);
endif;
@--------Set some basic parameters to describe the data.-----------------@

nyr = 32;
fyr = 1978;

   nco = rows(dta)/nyr;
@-----------This part rearranges things in cities instead of in years----------@

restr = 1;
do while restr <=1;



capR    = 1.05;
do while capR <=1.05;
"====================================================== capR = ";; capR;; "===================================================";



@-------These are place holders for the moment conditions and parameters-@
@-------for the bootstrap. ----------------------------------------------@

clear fsave, csave, fsavet, csavet, delsave, lambsave;
if ncount>0;

tsave = zeros(ncount,nc);
tdelsave = zeros(ncount,1);
tlamsave = zeros(ncount,1);

else;

clear tsave,tdelsave,tlamsave;

endif;

@------These just pick out current and lagged values.-------------------@

pickmsa  = seqa(1,1,nco);
pickyear = seqa(1,1,nyr-numlag);
pick0 = zeros(nco*(nyr-numlag),1);
pick1 = zeros(nco*(nyr-numlag),1);
pick2 = zeros(nco*(nyr-numlag),1);
pick3 = zeros(nco*(nyr-numlag),1);
pick4 = zeros(nco*(nyr-numlag),1);
pick5 = zeros(nco*(nyr-numlag),1);
for ii(1,nco,1);
   pick0[(ii-1)*(nyr-numlag)+1:ii*(nyr-numlag),1] = (ii-1)*(nyr-0) + pickyear + 5;   /* current */
   pick1[(ii-1)*(nyr-numlag)+1:ii*(nyr-numlag),1] = (ii-1)*(nyr-0) + pickyear + 4;   /* lagged once */
   pick2[(ii-1)*(nyr-numlag)+1:ii*(nyr-numlag),1] = (ii-1)*(nyr-0) + pickyear + 3;   /* lagged twice */
   pick3[(ii-1)*(nyr-numlag)+1:ii*(nyr-numlag),1] = (ii-1)*(nyr-0) + pickyear + 2;   /* lagged twice */
   pick4[(ii-1)*(nyr-numlag)+1:ii*(nyr-numlag),1] = (ii-1)*(nyr-0) + pickyear + 1;   /* lagged twice */
   pick5[(ii-1)*(nyr-numlag)+1:ii*(nyr-numlag),1] = (ii-1)*(nyr-0) + pickyear + 0;   /* lagged twice */
endfor;


clear c;
@-----------------This is the beginning of the bootstrap loop.-----------@
s1 = 1;                       @ Set the seed. @
bb = 1;
do while bb <= (ncount+1);

    if floor(bb/10)==bb/10;   @ See where on earth you are in the boostrap.@
       output off;
       bb;
       output on;
    endif;
    bttfdb:                   @ A restart point in case something doesn't invert. @

@---------This bit resamples by MSA--------------------------------------@

    if bb > 1;
       pickobs = floor(rndus(nco,1,s1)*nco)+1;
       bootdta = zeros(rows(dta),cols(dta));
       for fff(1,nco,1);
          bootdta[(fff-1)*nyr+1:fff*nyr,.] = dta[(pickobs[fff,1]-1)*nyr+1:pickobs[fff,1]*nyr,.];
       endfor;

    endif;


@--------This part puts it in hat form.---------------------------------------------------------@
    if doraw == 1;
       let hatidx = 3 4 5 6 7 22 23;
       hidx = seqa(1,nyr,nco);
       for yy(1978,2009,1);
          if bb == 1;
            dtai  = selif(dta,dta[.,2].==yy);
          else;
            dtai  = selif(bootdta,bootdta[.,2].==yy);
          endif;

          dtai = dtai - meanc(dtai)';

          if bb == 1;
            dta[hidx+yy-1978,hatidx] = dtai[.,hatidx];
          else;
            bootdta[hidx+yy-1978,hatidx] = dtai[.,hatidx];
          endif;
       endfor;
    endif;
@------------This part gets time t-0,t-1,t-2,t-3,t-4 data.-----------------------------@
    if bb == 1;
      dta0 = dta[pick0,.];
      dta1 = dta[pick1,.];
      dta2 = dta[pick2,.];
      dta3 = dta[pick3,.];
      dta4 = dta[pick4,.];
      dta5 = dta[pick5,.];
    else;
      dta0 = bootdta[pick0,.];
      dta1 = bootdta[pick1,.];
      dta2 = bootdta[pick2,.];
      dta3 = bootdta[pick3,.];
      dta4 = bootdta[pick4,.];
      dta5 = bootdta[pick5,.];
    endif;
    deldta0 = dta0 - dta1;
    deldta1 = dta1 - dta2;
    deldta2 = dta2 - dta3;
    deldta3 = dta3 - dta4;
    deldta4 = dta4 - dta5;


    @------Define all of the variables.-----------------------------------------------@
    @------It isn't necessary to define all of them, but it is a useful check.--------@

    csbsa               = dta0[.,1];      @ cbsa                  @
    year                = dta0[.,2];      @ year                  @
    w_eit               = dta0[.,3];      @ lavgwagehi_hat        @
    r_hit               = dta0[.,4];      @ lrs2_hat              @
    q_it                = dta0[.,5];      @ lplevel_hat           @
    chi_it              = dta0[.,6];      @ lexpshare_hat         @
    m_it                = dta0[.,7];      @ lhilorat_hat          @
    dbt_kbt             = dta0[.,8];      @ dbt_kbt               @
    dst_kst             = dta0[.,9];      @ dst_kst               @
    dft_kft             = dta0[.,10];     @ dft_kft               @
    Erhit               = dta0[.,11];     @ Erhit                 @
    pbt                 = dta0[.,12];     @ pbt                   @
    pst                 = dta0[.,13];     @ pst                   @
    pft                 = dta0[.,14];     @ pft                   @
    landsh_h            = dta0[.,15];     @ landshare_housing     @
    landsh_k            = dta0[.,16];     @ landshare_buscapital  @
    labsh_o             = dta0[.,17];     @ laborshare_output     @
    infrsh_l            = dta0[.,18];     @ infrashare_land       @
    ct                  = dta0[.,19];     @ ct                    @
    vhp                 = dta0[.,20];     @ lhp                   @
    vpcy                = dta0[.,21];     @ lpersinc              @
    vhp_hat             = dta0[.,22];     @ lhp_hat               @
    vpcy_hat            = dta0[.,23];     @ lpersinc_hat          @
    vpcy_hat            = dta0[.,23];     @ lpersinc_hat          @
    pt                  = dta0[.,24];     @ lpbls_pop_agg         @
    @------Define all of the instruments. See how everything lines up.---------------@

    if restr == 0;

        let zidx =
        @ dta0[.,@3@];  @   @ w_eit         lavgwagehi_hat        @
        @ dta0[.,@4@];  @   @ r_hit         lrs2_hat              @
        @ dta0[.,@5@];  @   @ q_it          lplevel_hat           @
        @ dta0[.,@6@];  @   @ chi_it        lexpshare_hat         @
        @ dta0[.,@7@];  @   @ m_it          lhilorat_hat          @
        @ dta0[.,@22@]; @   @ vhp_hat       lhp_hat               @
        @ dta0[.,@23@]; @   @ vpcy_hat      lpersinc_hat          @
        ;
    elseif restr==1;
        let zidx = 3 4 5 6 7;
    endif;


    if diffs == 1;
       let zidx = 3 4 5 6 7 22 23;if bb==1; "------Instrument set from the Wright diagnostic.------------";endif;
@here@ z  = deldta4[.,zidx];
    else;
       let zidx = 3 4 5 6 7 22 23;if bb==1; "------Instrument set from the Wright diagnostic.------------";endif;
       z  = dta2[.,zidx];
    endif;
                @
    let z1idx = 4 5 7 22;
    let z2idx = 6;
    z  = deldta2[.,z1idx]~dta2[.,z2idx];        @

    numz = cols(z);

@------------------------------------------------------------------------------------------------------@
@------------------------------------------------------------------------------------------------------@
@----------------End of the data setup. Now this is the core estimation.-------------------------------@
@------------------------------------------------------------------------------------------------------@
@------------------------------------------------------------------------------------------------------@




    c = ones(nc,1);
    let cstart =                 @This just makes the time-series stuff converge a lot faster.@
          0.096176               @It is not necessary.@
          0.016219
          0.023413
          4.706393
          0.994880
          4.484655
          1.006886
          4.533970
          1.005660
          0.690214
          0.312293
          1.009683
          8.929044
          0.992346
          0.544387
         10.211865
          1.016091
         12.038364
          1.012025;
      c[1:19,1] = cstart;


    stderr = zeros(nc,1);
  @  if bb == 1; "starting value = ";; c';endif;  @

    /* The first part will get the parameters and influence functions from the time series moment conditions */
    errflag = 0;
    weight = 0;
    ceename = cname[1:19,1];
    shorter = 1;
    nlag = 0;
    cee = c[1:19,1];
    { caux,vct,inflnct,chisq,mf,errflag } = minim(cee,&deff2);
    c[1:19,1] = caux;
    stdi = sqrt(diag(vct));
    stderr[1:19,1] = stdi;
    if bb == 1;
       csavet = caux;
    else;
       tsave[bb-1,1:19]  = ((caux-csavet)./stdi)';
    endif;
    @stdi; sqrt(diag(moment(inflnct,0)/rows(inflnct)^2));end;  @

    /* This makes the time-series influence functions conformable with the micro influence functions. */
    for ii(1,cols(inflnct),1);
        if ii == 1;
            timeinfl=vec(inflnct[.,ii]*ones(1,nco));
        else;
            timeinfl=timeinfl~vec(inflnct[.,ii]*ones(1,nco));
        endif;
    endfor;
    timeinfl = timeinfl*sqrt(nco);            /* This makes sure you divide by T instead of NT */
  @  timeinfl = zeros(rows(timeinfl),cols(timeinfl));       Interesting.....if you put this in, then things become significant. So it's useful to do the two-step thing.@

    @---------------Now extract all of the parameters and influence functions.------------------------@
    kappa_b = caux[1,1];          Ikappa_b = timeinfl[.,1];
    kappa_s = caux[2,1];          Ikappa_s = timeinfl[.,2];
    kappa_f = caux[3,1];          Ikappa_f = timeinfl[.,3];
    pb0     = caux[4,1];          Ipb0     = timeinfl[.,4];
    gpb     = caux[5,1];          Igpb     = timeinfl[.,5];
    ps0     = caux[6,1];          Ips0     = timeinfl[.,6];
    gps     = caux[7,1];          Igps     = timeinfl[.,7];
    pf0     = caux[8,1];          Ipf0     = timeinfl[.,8];
    gpf     = caux[9,1];          Igpf     = timeinfl[.,9];
    omega   = caux[10,1];         Iomega   = timeinfl[.,10];
    alpha   = caux[11,1];         Ialpha   = timeinfl[.,11];
    gpl     = caux[12,1];         Igpl     = timeinfl[.,12];
    Erh_0   = caux[13,1];         IErh_0   = timeinfl[.,13];
    phi     = caux[14,1];         Iphi     = timeinfl[.,14];
    zayta    = caux[15,1];         Izayta    = timeinfl[.,15];
    c0      = caux[16,1];         Ic0      = timeinfl[.,16];
    gc      = caux[17,1];         Igc      = timeinfl[.,17];
    n0      = caux[18,1];         In0      = timeinfl[.,18];
    gn      = caux[19,1];         Ign      = timeinfl[.,19];
   @ capR   = caux[10,1];         capR     = timeinfl[.,10];      @

    @----------------Now the main estimation.----------------------------------@

    /* This bit sets parameters for the GMM routine. */
    shorter = 0;
    errflag = 0;
    weight = 0;
    nlag = 8;
    ceename = cname[20:21,1];
    cee = c[20:21,1];@ if bb>1; let cee = 1.04 0.54;endif;  @
    /* This calls the GMM routine */
    { caux, vci, infl, chisq, momfun, errflag } = minim(cee,&deff);

    /* If the bootstrap trial throws up, try again. */
    if errflag == 1; goto bttfdb; endif;

    /* Extract the parameters from the c vector. */
    c[20:21,1] = caux;
    stdi = sqrt(diag(vci));
    stderr[20:21,1] = stdi;
    delta = caux[1,1];         Idelta = infl[.,1];
    xi    = caux[2,1];         Ixi    = infl[.,2];
    degf = cols(z)-rows(caux);


    @--------Now do the final consumption part--------------------------------------------------------@

    ceeee = gc|
            gn|
            gpf|
            phi|
            alpha|
            delta|
            zayta;

    bigphi = Igc~
             Ign~
             Igpf~
             Iphi~
             Ialpha~
             Idelta~
             Izayta;


    del = lam(ceeee);
    gee    = gradp(&lam,ceeee)';


    avar = moment(bigphi,0)/rows(bigphi)^2;   /* this is squared because one "n" takes the average and the other "n"
                                                 takes care of the fact that we are dealing with a sample average. */


    avar = newey2(bigphi,14);              if iscplx(avar);goto bttfdb; endif;

    stddel = sqrt(gee'avar*gee);

    @--------------------Now test for gstar.-----------------------------------------------------------------------------@

    gcstar = gstar(ceeee);
    gee    = gradp(&gstar,ceeee)';


    avar = moment(bigphi,0)/rows(bigphi)^2;   /* this is squared because one "n" takes the average and the other "n"
                                                 takes care of the fact that we are dealing with a sample average. */

    avar = newey2(bigphi,14);
    stdstar = sqrt(gee'avar*gee);

    @-----------------------Test on the growth rate restrictions.--------------------------------------------------------@
    tse = gc   |
          gn   |
          gpf  |
          gpl  |
          zayta ;

    bigphi =  Igc   ~
              Ign   ~
              Igpf  ~
              Igpl  ~
              Izayta ;

    cf = gstat(tse);
    gee = gradp(&gstat,tse)';
    let testidx = gc gn gpf gpl zayta;
    testidx = indcv(testidx,cname);
    avar = vct[testidx,testidx];

    @avar = moment(bigphi,0)/rows(bigphi)^2;   /* this is squared because one "n" takes the average and the other "n"
                                                 takes care of the fact that we are dealing with a sample average. */

    avar = newey2(bigphi,14);   @
    stdcf = sqrt(gee'avar*gee);

    @-----------------------First counterfactual test on growth rates.----------------------------------------------@

    eff = zeros(2,1);
  @  eff[1,1] = gpf - gpl;     @
    eff[1,1] = gpl - gc*gn;
    eff[2,1] = gpf - gc*gn;

    bigphi = Igpf~
             Igpl~
             Igc~
             Ign;


    gee = zeros(2,4);

@   gee[1,1] =  1;         gee[1,2] = -1;          gee[1,3] = 0;           gee[1,4] = 0;@
    gee[1,1] =  0;         gee[1,2] = 1;           gee[1,3] = -gn;         gee[1,4] = -gc;
    gee[2,1] =  1;         gee[2,2] = 0;           gee[2,3] = -gn;         gee[2,4] = -gc;


    let testidx = gpf gpl gc gn;
    testidx = indcv(testidx,cname);
    avar = vct[testidx,testidx];


    @avar = moment(bigphi,0)/rows(bigphi)^2;   /* this is squared because one "n" takes the average and the other "n"
                                                 takes care of the fact that we are dealing with a sample average. */
    avar = newey2(bigphi,10); @
    testvar = gee*avar*gee';
    wald1 = (nyr-numlag)*eff'invpd(testvar)*eff/rows(bigphi);

    @-----------------------Second counterfactual test on growth rates.----------------------------------------------@

    eff = zeros(3,1);
    eff[1,1] = gpb - 1;
    eff[2,1] = gps - 1;
    eff[3,1] = gpf - 1;

    bigphi = Igpb~
             Igps~
             Igpf;


    gee = eye(3);

    @avar = moment(bigphi,0)/rows(bigphi)^2;   /* this is squared because one "n" takes the average and the other "n"
                                                 takes care of the fact that we are dealing with a sample average. */

    avar = newey2(bigphi,10);@

    let testidx = gpb gps gpf;
    testidx = indcv(testidx,cname);
    avar = vct[testidx,testidx];

    testvar = gee*avar*gee';
    wald2 = (nyr-numlag)*eff'invpd(testvar)*eff/rows(bigphi);

    @-----------------------The final two sets of tests.-------------------------------------------------------------@

    eff = zeros(2,1);
    eff[1,1] = ((gc/gpf))^zayta*(gn^(zayta-1)) - 1;
    eff[2,1] = gc/gpl - 1;


    gee = zeros(2,5);

    gee[1,1] =  0;         gee[1,2] = 1;           gee[1,3] = -gn;         gee[1,4] = -gc;
    gee[2,1] =  1;         gee[2,2] = 0;           gee[2,3] = -gn;         gee[2,4] = -gc;



gee[1,1] = (zayta/(gpf))*gn^(zayta-1)*(((gc)/(gpf)))^(zayta-1)   ;

gee[1,2] = -zayta*((gc)/(gpf^2))*gn^(zayta-1)*(((gc)/(gpf)))^(zayta-1)    ;


gee[1,3] = (ln( gn))*gn^(zayta-1)*(((gc)/(gpf)))^zayta+gn^(zayta-1)*(ln((gc)/(gpf)))*(((gc)/(gpf)))^zayta      ;


gee[1,4] = (zayta-1)*gn^(zayta-2)*(((gc)/(gpf)))^zayta      ;


gee[1,1] =  1/gpl;

gee[1,5] =  -gc/gpl^2;

    let testidx = gc gpf zayta gn gpl;
    testidx = indcv(testidx,cname);
    avar = vct[testidx,testidx];

    testvar = gee*avar*gee';
    wald4 = (nyr-numlag)*eff'invpd(testvar)*eff/(nyr-numlag);

    @--------------------Morris' alternate test on whether Lambda > 0 --------------------------------------------@


    tse = gc   |
          gn   |
          gpf  |
          delta|
          phi  |
          zayta ;

    bigphi =  Igc~
              Ign~
              Igpf~
              Idelta~
              Iphi~
              Izayta;

    thing = mess(tse);


    gee = gradp(&mess,tse)';
    avar = moment(bigphi,0)/rows(bigphi)^2;   /* this is squared because one "n" takes the average and the other "n"
                                                 takes care of the fact that we are dealing with a sample average. */

    avar = newey2(bigphi,14);
    stdthing = sqrt(gee'avar*gee);

  @------------------------A test of whether lambda = 0.---------------------------------------@

   bigphi = Idelta~Iphi;

   gee = zeros(2,1);
   gee[1,1] = 1/phi;
   gee[2,1] = -delta/(phi^2);

   avar = newey2(bigphi,14);
   lamb    = delta/phi;
   stdlamb = sqrt(gee'avar*gee);


    if bb == 1;
       lambsave = lamb;
       delsave = del;
       csave   = caux;
       fsave   = momfun;
    else;
       tlamsave[bb-1,1] = (lamb - lambsave)/stdlamb;
       tdelsave[bb-1,1] = (del - delsave)/stddel;
       tsave[bb-1,20:21] = ((caux-csave)./stdi)';
    endif;


    if bb==1;

/*   This business makes a LaTeX table.   */
    format /rd 8,3;
    statsave = zeros(4,1);
    statsave[1,1] = (c[nc-1,1]-1)/stderr[nc-1,1];
    statsave[2,1] = c[nc,1]/stderr[nc,1];
    statsave[3,1] = del/stddel;
    statsave[4,1] = lamb/stdlamb;

    format /rd 12,4;
    format /rd 12,3;
    for qq(1,nc,1);
    $cname[qq,1];; " & ";; c[qq,1];;      "  \\" "\\";
    "              &(";; stderr[qq,1];; ") \\" "\\";
    endfor;
    "         DEL  & ";; del;; "  \\" "\\";
    "              &(";; stddel;; ") \\" "\\";

    "       lambda & ";; lamb;; "  \\" "\\";
    "              &(";; stdlamb;; ") \\" "\\";


    " J-test       & ";; chisq;; "  \\" "\\";
    " p-value      &(";; cdfchic(chisq,degf);;  ") \\" "\\";
    " d.o.f.       & ";; degf;;  "  \\" "\\";


    { m2,tstat,pval } = m2m3((delta|xi|omega|alpha),deldta0[.,3],deldta0[.,4:7],deldta2[.,3],deldta2[.,4:7]);

    " m2 test      & ";; tstat;; "  \\" "\\";
    " p-value      &(";; pval;;  ") \\" "\\";


    { m2,tstat,pval } = m2m3((delta|xi|omega|alpha),deldta0[.,3],deldta0[.,4:7],deldta3[.,3],deldta3[.,4:7]);

    " m3 test      & ";; tstat;; "  \\" "\\";
    " p-value      &(";; pval;;  ") \\" "\\";



    "Growth rate test   ";; cf/stdcf;; cdfn(cf/stdcf);
    "Gcstar =gc         ";; (gcstar-0)/stdstar;
    "Wald 1             ";; wald1;; cdfchic(wald1,2);
    "Wald 2             ";; wald2;; cdfchic(wald2,3);
    "Morris test        ";; thing/stdthing;

    "Wald 4             ";; wald4;; cdfchic(wald4,2);

"--------------------------------------------/*   This business makes a differently formatted LaTeX table.-------------------------------------   */";
    format /rd 12,3;
    for qq(1,nc,1);
    $cname[qq,1];; " & ";; c[qq,1];;  " &";; stderr[qq,1];; "\\" "\\";
    endfor;
    "          DEL & ";; del;;  " &";; stddel;;  "\\" "\\";
    "       lambda & ";; lamb;; " &";; stdlamb;; "\\" "\\";


    endif;



bb = bb + 1;
endo;             /*bootstrap loop*/

if ncount > 0;


for sss(1,cols(tsave),1);
  tsave[.,sss] = sortc(tsave[.,sss],1);
endfor;
tdelsave = sortc(tdelsave,1);
tlamsave = sortc(tlamsave,1);

if ncount>0;
"Lower and Upper 5% Critical values for the t-test ";

for sss(nc-1,nc,1);
$cname[sss,1];; " & ";; tsave[floor(rows(tsave)*0.025),sss];; " & ";; tsave[floor(rows(tsave)*0.975),sss];; " \\ \\ ";
endfor;
"          DEL & ";;  tdelsave[floor(rows(tdelsave)*0.025),1];; " & ";; tdelsave[floor(rows(tdelsave)*0.975),1];; " \\ \\ ";
"        lambda& ";;  tlamsave[floor(rows(tlamsave)*0.025),1];; " & ";; tlamsave[floor(rows(tlamsave)*0.975),1];; " \\ \\ ";
endif;

"Bootstrapped Pvalues ";

distto =  abs((tsave[.,nc-1:nc]~tdelsave~tlamsave)-statsave');

pvalues = zeros(cols(distto),1);

for mmm(1,cols(distto),1);
pvalues[mmm,1] = 1-indnv(minc(distto[.,mmm]),distto[.,mmm])/rows(distto);
endfor;
$(cname[nc-1:nc,1]')~"     DEL       "~"     lambda     ";
pvalues';

endif;

capR = capR + 0.01;
endo;


restr = restr + 1;
endo;

@------------------This subroutine makes capLambda.---------------------------------------------@


    proc lam(c);
    local gc, gn, gpf, phi, alpha, delta, zayta, denom, e1, e2, e3, gstar, lambda;

    gc     = c[1,1];
    gn     = c[2,1];
    gpf    = c[3,1];
    phi    = c[4,1];
    alpha  = c[5,1];
    delta  = c[6,1];
    zayta   = c[7,1];

    denom = delta*(1 - alpha*phi - zayta*(1 - phi));

    e1 = phi*(1 - alpha*delta - zayta*(1 - delta))/denom;

    e2 = (phi - delta)*(1 - zayta)/denom;

    e3 = zayta*(phi - delta)/denom;

    gstar = (gc^e1) * (gn^e2) * (gpf^e3);

    lambda = (gc - gstar)/(gstar - 1);

    retp(lambda);
    endp;

    proc gstar(c);
    local gc, gn, gpf, phi, alpha, delta, zayta, denom, e1, e2, e3, gstar, lambda;

    gc     = c[1,1];
    gn     = c[2,1];
    gpf    = c[3,1];
    phi    = c[4,1];
    alpha  = c[5,1];
    delta  = c[6,1];
    zayta   = c[7,1];

    denom = delta*(1 - alpha*phi - zayta*(1 - phi));

    e1 = phi*(1 - alpha*delta - zayta*(1 - delta))/denom;

    e2 = (phi - delta)*(1 - zayta)/denom;

    e3 = zayta*(phi - delta)/denom;

    gstar = (gc^e1) * (gn^e2) * (gpf^e3);


    retp(gstar-gc);
    endp;

@------------------This subroutine makes the test stat for the growth rate condition. ----------@


    proc gstat(c);
    local gc, gn, gpf, gpl, zayta, cf;

    gc     = c[1,1];
    gn     = c[2,1];
    gpf    = c[3,1];
    gpl    = c[4,1];
    zayta   = c[5,1];

    cf = gpl - (gc^(1-zayta)) * (gn^(1-zayta)) * (gpf^zayta);

    retp(cf);
    endp;

@-----------Subroutine to calculate Morris' alternate test.--------------------@

    proc mess(c);

       local gc, gn, gpf, delta, phi, zayta, thing, thing1, thing2;

       gc     = c[1,1];
       gn     = c[2,1];
       gpf    = c[3,1];
       delta  = c[4,1];
       phi    = c[5,1];
       zayta   = c[6,1];

       thing1 = zayta*ln(gpf);
       thing2 = ln(gc) + ln(gn);

       thing = (delta - phi)*( (1 - zayta)*thing2 + thing1);

       retp(thing);

    endp;



    proc gradlam(c);


    local gc, gn, gpf, phi, alpha, delta, zayta, denom, e1, e2, e3, gstar,
          gee, dstardgc, dstardgn, dstardgf, dlamstar;

    gc     = c[1,1];
    gn     = c[2,1];
    gpf    = c[3,1];
    phi    = c[4,1];
    alpha  = c[5,1];
    delta  = c[6,1];
    zayta   = c[7,1];
    gee    = zeros(7,1);


    denom = delta*(1 - alpha*phi - zayta*(1 - phi));

    e1 = phi*(1 - alpha*delta - zayta*(1 - delta))/denom;

    e2 = (phi - delta)*(1 - zayta)/denom;

    e3 = zayta*(phi - delta)/denom;

    gstar = (gc^e1) * (gn^e2) * (gpf^e3);
    dstardgc = e1*(gc^(e1-1))* (gn^(e2-0)) * (gpf^(e3-0));
    dstardgn = e2*(gc^(e1-0))* (gn^(e2-1)) * (gpf^(e3-0));
    dstardgf = e3*(gc^(e1-0))* (gn^(e2-0)) * (gpf^(e3-1));
    dlamstar = 1/(1 - gstar) - (gc-gstar)/((1 - gstar)^2);

    gee[1,1] = 1/(gstar - 1) - dstardgc* (gc/(gstar-1)^2 + 1/(gstar - 1)  - gstar/(gstar-1)^2 );
    gee[2,1] = dlamstar*dstardgn;
    gee[3,1] = dlamstar*dstardgf;


    retp(gee);
    endp;

@--------The next three subroutines (the first two are grouped) make the actual moment conditions.@
@----------------Subroutine to make the nonlinear part linear.--------------------@

proc transc(c);
    local b, delta, xi, omega, alpha;

    delta  = c[1,1];
    xi     = c[2,1];
    omega  = c[3,1];
    alpha  = c[4,1];
    b = zeros(4,1);
    b[1,1] = ( 1/(1 - omega) ) * (delta - 1)/(delta*(1-alpha));
    b[2,1] = 1/(delta*(1-alpha));
    b[3,1] = (1-xi)/xi;
    b[4,1] = xi - 1;

    retp(b);
    endp;


@----------------------Subroutine to define the f vector.------------------------@

proc deff(c);

    local b, f, u, y, x, ei, delta;

    f  = zeros((nyr-numlag)*nco,numz);
    ei = zeros((nyr-numlag)*nco,numz);

    @ ---------------The first two sets of moment conditions.------------@
    y = deldta0[.,3];      @     w_eit             lavgwagehi_hat        @
    x = deldta0[.,4]~      @     r_hit             lrs2_hat              @
        deldta0[.,5]~      @     q_it              lplevel_hat           @
        deldta0[.,6]~      @     chi_it            lexpshare_hat         @
        deldta0[.,7];      @     m_it              lhilorat_hat          @

    b = transc(c|omega|alpha);

    u = y - x*b;

    f = z.*u;

    delta = c[1,1];
    ei = z.*(( deldta0[.,4]*(delta-1)/(delta*(alpha-1)*(omega-1)^2)).*Iomega   +
         ( deldta0[.,4]*(delta-1)/(delta*(omega-1)*(alpha-1)^2) - deldta0[.,5]/(delta*(alpha-1)^2)).*Ialpha);

    if weight == 1;
      retp(f+ei);
    else;
      retp(meanc(f));
    endif;

    endp;



@ ---------Subroutine for the first set of auxilliary parameters.-------------------@


proc deff2(c);
    local kappa_b, kappa_s, kappa_f, pb0, gpb, ps0, gps, pf0, gpf, pb, des,
          tee, f, u, gpl, Erh_0, phi, zayta, omega, alpha, c0, gc, n0, gn;

    kappa_b = c[1,1];
    kappa_s = c[2,1];
    kappa_f = c[3,1];
    pb0     = c[4,1];
    gpb     = c[5,1];
    ps0     = c[6,1];
    gps     = c[7,1];
    pf0     = c[8,1];
    gpf     = c[9,1];
    omega   = c[10,1];
    alpha   = c[11,1];
    gpl     = c[12,1];
    Erh_0   = c[13,1];
    phi     = c[14,1];
    zayta    = c[15,1];
    c0      = c[16,1];
    gc      = c[17,1];
    n0      = c[18,1];
    gn      = c[19,1];

    /* depreciation rates */

    f = zeros(nyr-numlag,neq);

    f[.,1] = (dbt_kbt[1:nyr-numlag] - kappa_b);
    f[.,2] = (dst_kst[1:nyr-numlag] - kappa_s);
    f[.,3] = (dft_kft[1:nyr-numlag] - kappa_f);

    /* aggregate growth rates */


    pb = ln(pbt~pst~pft);  /* the data are in levels and they need to be logged */

    tee = seqa(1,1,nyr-numlag);
    des = ones(nyr-numlag,1)~tee;
    for ii(1,3,1);
       u = pb[1:nyr-numlag,ii] - c[(ii+1)*2,1] - ln(c[(ii+1)*2+1,1])*tee;
       f[.,(ii+1)*2:(ii+1)*2+1] = des.*u;
    endfor;

    /* the more complicate aggregate growth rate */


    u = ln(Erhit[1:nyr-numlag]) - Erh_0 - ( (1-omega)*ln(gpl) + omega*ln(gps)         )*tee;
    f[.,10:11] = des.*u;


    /* the "share" parameters */

    f[.,12] = landsh_h[1:nyr-numlag] * ( (omega/(1-omega))  *(   capR/gpl - (1-kappa_f)^zayta)/(capR/gps + kappa_s - 1) + 1 ) - 1;
    f[.,13] = landsh_k[1:nyr-numlag] * ( (alpha*phi/(1-phi))*(   capR/gpl - (1-kappa_f)^zayta)/(capR/gpb + kappa_b - 1) + 1   ) - 1;


    f[.,14] = labsh_o[1:nyr-numlag] - phi*(1-alpha);
    f[.,15] = infrsh_l[1:nyr-numlag]  - zayta*(capR/gpl - (1-kappa_f)^zayta) / (capR/gpf - (1-kappa_f));



    u = ln(ct[1:nyr-numlag]) - c0 - ln(gc)*tee;
    f[.,16:17] = des.*u;

    u = pt[1:nyr-numlag] - n0 - ln(gn)*tee;
    f[.,18:19] = des.*u;

    if weight == 1;
      retp(f);
    else;
      retp(meanc(f));
    endif;

    endp;

@------------------The main GMM routine.----------------------------------@


proc (6) = minim(startval,&definef);
   local definef:proc;
   local rr, iter, ff, w, dc, gwf, f, g, obj, gwg, sqz, bvc, errflag, mm, c, nobs, lambda,
         c_new, bff, bf, bw, bg, gvc, bstderr, vc, stderr, inflnc, chisq, degf, pval;

   c = startval;
   errflag = 0;
   clear chisq;
   rr = 1;
   do until rr > rlim;

   @ ----------The program creates the weighting matrix. ----------------@
   iter = 0;
   weight = 1;
   ff = definef(c);
   nobs = rows(ff);
   weight = 0;


   if shorter == 1;
        w = newey(ff,nlag);
   else;
        ff = ff - (bb>1)*fsave';
        if cluster == 1 and onlyerr == 0;
           w = clust(ff);
        elseif cluster == 1 and onlyerr == 1;
            w = newey(ff,nlag);
        elseif cluster == 0;
            w = newey(ff,nlag);
        endif;
   endif;

   if w == -999999;
     errflag = 1;
     retp(1,1,1,1,1,errflag);
     goto theend;
   endif;

        @ ----------------- Start of iteration loop --------------------------------@
   iter = 1;
   dc=1;                     @ Initialize the step length. @
   gwf=1;
   do until abs(dc) < tol;

       f=definef(c);                @ The program jumps to the subroutine that
                                  defines the f vector. @

      if shorter == 0;
          f=f-(bb>1)*fsave;
      endif;


       g=gradp(&definef,c);         @ The program jumps to the subroutine that
                                   computes analytic derivatives. The matrix
                                   of partials of f with respect to the
                                   parameters is called g. @

       obj = f'w*f;              @ This computes the value of the objective
                                   function.@

       gwg= g'w*g;               @ This uses the GAUSS-NEWTON method
                                   to compute full step dc. @
       gwf = g'w*f;

       dc = solvit(gwf,gwg);
       if scalerr(dc) > 0;
         errflag = 1;
         retp(1,1,1,1,1,errflag);
         goto theend;
       endif;



       if maxsqez > 0;              @ This jumps to the subroutine that
                                      adjusts the step length. @
         { c_new,sqz } = squeeze(c,dc,w,obj,&definef);
       else;
         c_new=c - dc;
       endif;


       dc=c_new-c;                     @ Update variables for the next iteration. @
       c=c_new;


      /*------------------Print out the results for the current iteration---------------- */
      if bb == 1;
      if floor(iter/1000) == (iter/1000);
      output off;
      "Round Number       = ";; rr;
      "Iteration Number   = ";; iter;
      "Number of Squeezes = ";; sqz;
      "Objective Function = ";; obj*nobs;

      "                                  Value           Step                Gradient";
       format /rd 14,6;
       mm=1;
       do until mm > rows(c);
        $ceename[mm,1];;"  ";; c[mm,1];; "  ";; dc[mm,1];;  "  ";@; gwf[mm,1]; @
        mm=mm+1;
        endo;

      output on;

      endif;
      endif;
      /* ----------------------End of print out of current iteration------------------*/

      iter=iter +1;
      if iter >= maxiter or key==27;                     @ Quit iterating if necessary. @
        goto escape;
      endif;
   endo;
   @ -------- End of iteration loop ------------------------------------------------ @
   escape:

   if rr == rlim;

   @ Compute t-ratios, etc.                                            @

           weight = 1;
             ff = definef(c);
           weight = 0;

           f = definef(c);
           if shorter == 0;
              f = f - (bb>1)*fsave;
           endif;

           if shorter == 1;
                w = newey(ff,nlag);
           else;
                ff = ff - (bb>1)*fsave';
                if cluster == 1 and onlyerr == 0;
                   w = clust(ff);
                elseif cluster == 1 and onlyerr == 1;
                   w = newey(ff,nlag);
                   lambda = invpd(clust(ff));
                elseif cluster == 0;
                   w = newey(ff,nlag);
                endif;
           endif;



           if w == -999999;
             errflag = 1;
             retp(1,1,1,1,1,errflag);
             goto theend;
           endif;

           g=gradp(&definef,c);

           gwg = g'w*g;


           if shorter == 1;
                 vc=invpd(gwg)/nobs;
           else;
                if cluster == 1 and onlyerr == 0;
                   vc=invpd(gwg)/nobs;
                elseif cluster == 1 and onlyerr == 1;
                   vc=invpd(gwg)*(g'w*lambda*w*g)*invpd(gwg)/nobs;
                elseif cluster == 0;
                   vc=invpd(gwg)/nobs;
                endif;
           endif;
                         @  inv( gwg/nobs); print; (nobs^2*vc*g'w*ff'ff*w*g*vc); vc*100; 100*inv(gwg)/nobs; end;    @
           inflnc=-nobs*vc*g'w*ff';
           stderr=sqrt(diag(vc));
           inflnc=inflnc';
                              @   inflnc = sqrt(diag(moment(inflnc,0)/rows(inflnc))); (stderr-inflnc);end;       @
           chisq = obj*nobs;
           degf=rows(f) - rows(c);
           pval = cdfchic(chisq,degf);
      endif;
   rr = rr + 1;
   endo;

          @  100*(c[5 7 9,1]-1); 100*stdc((vc[5 7 9, 5 7 9])); inflnct = vc;
             (c[5 7 9,1]-1)'invpd(vc[5 7 9,5 7 9])*(c[5 7 9,1]-1);end;
          @






   retp(c,vc,inflnc,chisq,f,errflag);

   theend:
   endp;

@ ----------------------------------------------------------------------------@
@ Subroutines to compute the clustered and Newey West weighting matrices. @


proc clust(h);
local ff,qq,hi;

    ff = 0;
    for qq(1,nco,1);
        hi = sumc(h[(qq-1)*(nyr-numlag)+1:qq*(nyr-numlag),.]);
        ff = ff + hi*hi';
    endfor;

    ff = ff/rows(h);

ff = invit(ff);
if scalerr(ff)>0;
  retp(-999999);
else;
  retp(ff);
endif;

endp;

proc newey(h,rq);
local hminus,hplus,nn,ff,qq,fyr,eyr,hi,jj;

fyr=minc(year);
eyr=maxc(year);


ff = moment(h,0)/rows(h);

for qq(1,rq,1);
     if shorter == 0;
        hplus  = selif(h,(year.>=(fyr+qq)));
        hminus = selif(h,(year.<=(eyr-qq)));
     else;
        hplus  = selif(h,(year[1:nyr-numlag].>=(fyr+qq)));
        hminus = selif(h,(year[1:nyr-numlag].<=(eyr-qq)));
     endif;
     ff = ff + (1-(qq/(rq+1)))*(hminus'hplus + hplus'hminus)/rows(hplus);
endfor;

ff = invit(ff);
if scalerr(ff)>0;
  retp(-999999);
else;
  retp(ff);
endif;


clear hplus, hminus;

endp;

proc newey2(h,rq);
local hminus,hplus,nn,ff,qq,fyr,eyr,hi,jj;

fyr=minc(year);
eyr=maxc(year);


ff = moment(h,0)/rows(h)^2;

for qq(1,rq,1);
     if shorter == 0;
        hplus  = selif(h,(year.>=(fyr+qq)));
        hminus = selif(h,(year.<=(eyr-qq)));
     else;
        hplus  = selif(h,(year[1:nyr-numlag].>=(fyr+qq)));
        hminus = selif(h,(year[1:nyr-numlag].<=(eyr-qq)));
     endif;
     ff = ff + (1-(qq/(rq+1)))*(hminus'hplus + hplus'hminus)/rows(hplus)^2;
endfor;

  retp(ff);

clear hplus, hminus;

endp;






@  ------------------------------------------------------------------------- @
@ Subroutine to compute squeezes.

  This subroutine compares the values of the objective function at the
  points c+s*dc and c+0.5*s*dc, with dc = the proposed change in the vector
  of parameters, and with step length s initially at 1. s is halved until
  minus the objective function stops declining.
@
proc (2) = squeeze(s_c,s_dc,w,obj,&sdeff);
local sdeff:proc;
local s_c1,s_lm,s_itr,lc1,s_c2,lc2,s_f1,s_f2;


    s_c1=s_c - s_dc; s_lm=1/2; s_itr=1;
      s_f1 = sdeff(s_c1);
    lc1 = s_f1'w*s_f1;
    clear s_f1;
  do until s_itr > maxsqez;

    s_c2=s_c-s_lm*s_dc;
      s_f2 = sdeff(s_c2);
    lc2 = s_f2'w*s_f2;
    clear s_f2;

    if lc1 <= lc2 and lc1 <= obj;

       retp(s_c1,s_itr-1); goto eoproc;

    else;

       s_c1=s_c2; s_lm=s_lm/2; lc1=lc2;
       s_itr=s_itr+1;

    endif;

  endo;
retp(s_c2,s_itr-1);

eoproc:
endp;


@-------------Subroutine to trap inversion errors----------------------@

proc invit(w);
local onemore,ww;
onemore = 1;
winv:
trap 1;
  ww = invpd(w);
trap 0;
  if scalerr(ww) > 0;
      if onemore == 1;
        call sysstate(14,1e-128);
        onemore = 0;
        goto winv;
      else;
        ww = -999999;
      endif;
  endif;

retp(ww);

endp;

@-------------Subroutine to trap solving errors----------------------@

proc solvit(a,b);
local dc,onemore;
    onemore = 1;
    solveit:
    trap 1;
    dc = solpd(a,b);
    trap 0;
    if scalerr(dc) > 0;
      if onemore == 1;
        call sysstate(14,1e-128);
        onemore = 0;
        goto solveit;
      else;
        dc = -999999;
      endif;
    endif;

retp(dc);
endp;

eop:

"Start time:  ";; timestr(ttt);
"End time:    ";; timestr(0);
"Start date:  ";; datestr(ddd);
"End date:    ";; datestr(0);

output off;
end;





proc (3) = m2m3(c,y,x,y_2,x_2);
        local nc, n, sigz, vecsigz, phiz, counter, qq, ee, sigyy, sigxy, sigyx, phiyy, phixy, phiyx, geephi, newinflnc,
              bigphi, gee, dvecsigzdbeta, mmm, s, vt, vt2, avar, ss, tstat, nx;

        nx = cols(x);

        n = rows(x);

        sigz = x'x_2/n;
        vecsigz = vec(sigz);

        phiz = zeros(n,nx^2);

        counter = 1;
        for qq(1,nx,1);
        for ee(1,nx,1);

        phiz[.,counter] = x[.,ee].*x_2[.,qq];

        counter = counter + 1;

        endfor;
        endfor;

        phiz = phiz - vecsigz';


        sigyy = y'y_2/n;
        sigxy = x'y_2/n;
        sigyx = y'x_2/n;

        phiyy = y.*y_2 - sigyy;
        phixy = x.*y_2 - sigxy';
        phiyx = y.*x_2 - sigyx;


        geephi = gradp(&transc,c);

        newinflnc = infl~Iomega~Ialpha;
        newinflnc = newinflnc*geephi;

        @ cls; rows(newinflnc);cols(newinflnc);rows(inflnc);cols(inflnc);end;@


        bigphi = newinflnc~phiyy~phixy~phiyx~phiz;

        gee = zeros(1,cols(bigphi));


        c = transc(c);

        dvecsigzdbeta = sigz'c + sigz*c;

        for mmm(1,nx,1);

        gee[1,mmm] =  -sigxy[mmm,1] - sigyx[1,mmm] + dvecsigzdbeta[mmm,1];

        endfor;


        gee[1,1*rows(c)+1] = 1;
        gee[1,1*rows(c)+2:2*rows(c)+1] = -c';
        gee[1,2*rows(c)+2:3*rows(c)+1] = -c';
        gee[1,3*rows(c)+2:cols(gee)]   = -vec(c*c')';

        vt  = (y-x*c);
        vt2 = (y_2-x_2*c);
        s   = vt'vt2/n;
        avar = moment(bigphi,0)./n^2;
        ss   = sqrt(diag(gee*avar*gee'));
        tstat = s/ss;

         retp(s,tstat,2*cdfnc(abs(tstat)));
         endp;
