@--------Preliminary stuff--------------------------------------------------------@
new ,60000;
ttt = time;
ddd = date;
cls;
call sysstate(14,1e-128);


@--------Name of the output file.-------------------------------------------------@

diffs = 1;

if diffs == 1;
output file = wright_diffs.txt reset;
else;
output file = wright_levels.txt reset;
endif;
format /rd 8,3;

@--------Set some basic parameters for the estimation.----------------------------@

numlag = 4;    /* number of dropped years because of lags, etc. */

neq = 19;      /* number of moment conditions -- not including the instrumented regressions */
nc = 21;       /* number of parameters */
let cname =    /* parameter names */

kappa_b    @ 1  @
kappa_s    @ 2  @
kappa_f    @ 3  @
pb0        @ 4  @
gpb        @ 5  @
ps0        @ 6  @
gps        @ 7  @
pf0        @ 8  @
gpf        @ 9  @
omega      @10  @
alpha      @11  @
gpl        @12  @
Erh_0      @13  @
phi        @14  @
zeta       @15  @
c0         @16  @
gc         @17  @
n0         @18  @
gn         @19  @
delta      @20  @
xi;        @21  @

rlim = 10;      /* max number of times to iterate on the weight matrix. */
maxsqez=40;     /* max number of backsteps per iteration. */
maxiter=200;  /* max number of iterations to minimize the GMM objective function. */
tol=1e-9;       /* convergence criterion. */
cluster = 1;   onlyerr = 0;  /* the cluster option is obvious. onlyerr means that you use the optimal weight matrix but cluster at the end. less efficient */
nlag = 0;
bb = 1;
@--------Read in the excel file.--------------------------------------------------@

dataset = "dfw110916.csv";
dta = SpreadsheetReadM(dataset,"a2:x705",1);

@--------Set some basic parameters to describe the data.-----------------@

nco = 22;
nyr = 32;
fyr = 1978;


capR    = 1.05;
do while capR <=1.05;
"====================================================== capR = ";; capR;; "===================================================";



@-------These are place holders for the moment conditions and parameters-@
@-------for the bootstrap. ----------------------------------------------@

clear fsave, csave, fsavet, csavet;


@------These just pick out current and lagged values.-------------------@

pickmsa  = seqa(1,1,nco);
pickyear = seqa(1,1,nyr-numlag);
pick0 = zeros(nco*(nyr-numlag),1);
pick1 = zeros(nco*(nyr-numlag),1);
pick2 = zeros(nco*(nyr-numlag),1);
pick3 = zeros(nco*(nyr-numlag),1);
pick4 = zeros(nco*(nyr-numlag),1);
for ii(1,nco,1);
   pick0[(ii-1)*(nyr-numlag)+1:ii*(nyr-numlag),1] = (ii-1)*(nyr-0) + pickyear + 4;   /* current */
   pick1[(ii-1)*(nyr-numlag)+1:ii*(nyr-numlag),1] = (ii-1)*(nyr-0) + pickyear + 3;   /* lagged once */
   pick2[(ii-1)*(nyr-numlag)+1:ii*(nyr-numlag),1] = (ii-1)*(nyr-0) + pickyear + 2;   /* lagged twice */
   pick3[(ii-1)*(nyr-numlag)+1:ii*(nyr-numlag),1] = (ii-1)*(nyr-0) + pickyear + 1;   /* lagged twice */
   pick4[(ii-1)*(nyr-numlag)+1:ii*(nyr-numlag),1] = (ii-1)*(nyr-0) + pickyear + 0;   /* lagged twice */
endfor;



      dta0 = dta[pick0,.];
      dta1 = dta[pick1,.];
      dta2 = dta[pick2,.];
      dta3 = dta[pick3,.];
      dta4 = dta[pick4,.];
    deldta0 = dta0 - dta1;
    deldta2 = dta2 - dta3;
    deldta3 = dta3 - dta4;


    @------Define all of the variables.-----------------------------------------------@
    @------It isn't necessary to define all of them, but it is a useful check.--------@

    csbsa               = dta0[.,1];      @ cbsa                  @
    year                = dta0[.,2];      @ year                  @
    w_eit               = dta0[.,3];      @ lavgwagehi_hat        @
    r_hit               = dta0[.,4];      @ lrs2_hat              @
    q_it                = dta0[.,5];      @ lplevel_hat           @
    chi_it              = dta0[.,6];      @ lexpshare_hat         @
    m_it                = dta0[.,7];      @ lhilorat_hat          @
    dbt_kbt             = dta0[.,8];      @ dbt_kbt               @
    dst_kst             = dta0[.,9];      @ dst_kst               @
    dft_kft             = dta0[.,10];     @ dft_kft               @
    Erhit               = dta0[.,11];     @ Erhit                 @
    pbt                 = dta0[.,12];     @ pbt                   @
    pst                 = dta0[.,13];     @ pst                   @
    pft                 = dta0[.,14];     @ pft                   @
    landsh_h            = dta0[.,15];     @ landshare_housing     @
    landsh_k            = dta0[.,16];     @ landshare_buscapital  @
    labsh_o             = dta0[.,17];     @ laborshare_output     @
    infrsh_l            = dta0[.,18];     @ infrashare_land       @
    ct                  = dta0[.,19];     @ ct                    @
    vhp                 = dta0[.,20];     @ lhp                   @
    vpcy                = dta0[.,21];     @ lpersinc              @
    vhp_hat             = dta0[.,22];     @ lhp_hat               @
    vpcy_hat            = dta0[.,23];     @ lpersinc_hat          @
    pt                  = dta0[.,24];     @ lpbls_pop_agg         @

    @------Define all of the instruments. See how everything lines up.---------------@


        let zidx =
        @ dta0[.,@3@];  @   @ w_eit         lavgwagehi_hat        @
        @ dta0[.,@4@];  @   @ r_hit         lrs2_hat              @
        @ dta0[.,@5@];  @   @ q_it          lplevel_hat           @
        @ dta0[.,@6@];  @   @ chi_it        lexpshare_hat         @
        @ dta0[.,@7@];  @   @ m_it          lhilorat_hat          @
        @ dta0[.,@22@]; @   @ vhp_hat       lhp_hat               @
        @ dta0[.,@23@]; @   @ vpcy_hat      lpersinc_hat          @
        ;

    if diffs == 1;
       z  = deldta2[.,zidx];
    else;
       z  = dta2[.,zidx];
    endif;
    @
    let z1idx = 4 5 7 22;
    let z2idx = 6;
    z  = deldta2[.,z1idx]~dta2[.,z2idx];
    @
    numz = cols(z);

@------------------------------------------------------------------------------------------------------@
@------------------------------------------------------------------------------------------------------@
@----------------End of the data setup. Now this is the core estimation.-------------------------------@
@------------------------------------------------------------------------------------------------------@
@------------------------------------------------------------------------------------------------------@


    c = ones(nc,1);
    let cstart =                 @This just makes the time-series stuff converge a lot faster.@
          0.096176               @It is not necessary.@
          0.016219
          0.023413
          4.706393
          0.994880
          4.484655
          1.006886
          4.533970
          1.005660
          0.690214
          0.312293
          1.009683
          8.929044
          0.992346
          0.544387
         10.211865
          1.016091
         12.038364
          1.012025;
      c[1:19,1] = cstart;



    stderr = zeros(nc,1);
  @  if bb == 1; "starting value = ";; c';endif;  @

    /* The first part will get the parameters and influence functions from the time series moment conditions */
    errflag = 0;
    weight = 0;
    ceename = cname[1:19,1];
    shorter = 1;
    nlag = 1;
    cee = c[1:19,1];
    { caux,stdi,inflnct,chisq,errflag } = minim(cee,&deff2);
    c[1:19,1] = caux;
    stderr[1:19,1] = stdi;

    /* This makes the time-series influence functions conformable with the micro influence functions. */
    for ii(1,cols(inflnct),1);
        if ii == 1;
            timeinfl=vec(inflnct[.,ii]*ones(1,nco));
        else;
            timeinfl=timeinfl~vec(inflnct[.,ii]*ones(1,nco));
        endif;
    endfor;
    timeinfl = timeinfl*sqrt(nco);            /* This makes sure you divide by T instead of NT */


    @---------------Now extract all of the parameters and influence functions.------------------------@
    kappa_b = caux[1,1];          Ikappa_b = timeinfl[.,1];
    kappa_s = caux[2,1];          Ikappa_s = timeinfl[.,2];
    kappa_f = caux[3,1];          Ikappa_f = timeinfl[.,3];
    pb0     = caux[4,1];          Ipb0     = timeinfl[.,4];
    gpb     = caux[5,1];          Igpb     = timeinfl[.,5];
    ps0     = caux[6,1];          Ips0     = timeinfl[.,6];
    gps     = caux[7,1];          Igps     = timeinfl[.,7];
    pf0     = caux[8,1];          Ipf0     = timeinfl[.,8];
    gpf     = caux[9,1];          Igpf     = timeinfl[.,9];
    omega   = caux[10,1];         Iomega   = timeinfl[.,10];
    alpha   = caux[11,1];         Ialpha   = timeinfl[.,11];
    gpl     = caux[12,1];         Igpl     = timeinfl[.,12];
    Erh_0   = caux[13,1];         IErh_0   = timeinfl[.,13];
    phi     = caux[14,1];         Iphi     = timeinfl[.,14];
    zeta    = caux[15,1];         Izeta    = timeinfl[.,15];
    c0      = caux[16,1];         Ic0      = timeinfl[.,16];
    gc      = caux[17,1];         Igc      = timeinfl[.,17];
    n0      = caux[18,1];         In0      = timeinfl[.,18];
    gn      = caux[19,1];         Ign      = timeinfl[.,19];
   @ capR   = caux[10,1];         capR     = timeinfl[.,10];      @

    @------This part gets the "S" set.----------------------------------------@

    /* This bit sets parameters for the GMM routine. */
    shorter = 0;
    errflag = 0;
    weight = 0;
    nlag = 8;

    setbord = cdfChincInv(0.95,numz-2,0);
    Sset = zeros(1,3);
            @
    for dd(0.1,5,0.05);       this is for diffs = 0;
    for xx(0.1,2,0.05);
                @
    for dd(0.1,2,0.05);
    for xx(0.1,1,0.05);
    cee = dd|xx;


    weight = 1;
    ff = deff(cee);
    weight = 0;
    f = deff(cee);


    if cluster == 1 and onlyerr == 0;
       w = clust(ff);
    else;
        w = newey(ff,nlag);
    endif;


    obj = rows(ff)*f'w*f;              @ This computes the value of the objective
                                function.@

    Sset = Sset | (dd~xx~obj);

    endfor;
    endfor;
    Sset = Sset[2:rows(Sset),.];
    Oset = selif(Sset,Sset[.,3].>setbord);
    Sset = selif(Sset,Sset[.,3].<=setbord);

    chisq = 10000000000;         rows(sset);
@    for ii(1,rows(Sset),1);   ii;@
    ii = 1;
    do while ii<=rows(Sset); ii;;
    cee = Sset[ii,1:2]';
    c = cee;

    startval = @rndu(cols(z)+1,1);@0.15*ones(cols(z)+1,1);
    chitest = minim2(startval,&deffB,&optwB);
    if chitest < chisq; chisq = chitest; endif;   chisq;
  @  endfor;     @
    ii = ii + 1; endo;
    chisq;
    cdfchic(chisq,cols(z)-1);


capR = capR + 0.03;
endo;


@--------The next three subroutines (the first two are grouped) make the actual moment conditions.@




proc deffB(startval);

local eff, gee, lc;
lc = startval[1:rows(startval)-1]|(startval[rows(startval)]*startval[1:rows(startval)-1]);
weight = 0;
gee = vec(gradp(&deff,cee)); @  rows(gee);cols(gee);rows(lc);cols(lc);  @
eff = gee - lc;
retp(eff);
endp;


proc optwB(startval);

local eff, gee, lc, ii, jj;
lc = startval[1:rows(startval)-1]|(startval[rows(startval)]*startval[1:rows(startval)-1]);

gee = zeros(rows(z),2*cols(z));
ii = 2;
do while ii <= (numz+1);
jj = ii -1;
weight = ii;
gee[.,jj (numz+jj)] = gradp(&deff,cee);
ii = ii + 1;
endo;
eff = gee - lc';

retp(eff);
endp;


@----------------Subroutine to make the nonlinear part linear.--------------------@
proc transc(c);
    local b, delta, xi, omega, alpha;

    delta  = c[1,1];
    xi     = c[2,1];
    omega  = c[3,1];
    alpha  = c[4,1];
    b = zeros(4,1);
    b[1,1] = ( 1/(1 - omega) ) * (delta - 1)/(delta*(1-alpha));
    b[2,1] = 1/(delta*(1-alpha));
    b[3,1] = (1-xi)/xi;
    b[4,1] = xi - 1;

    retp(b);
    endp;


@----------------------Subroutine to define the f vector.------------------------@

proc deff(c);

    local b, f, u, y, x, ei, delta;

    f  = zeros((nyr-numlag)*nco,numz);
    ei = zeros((nyr-numlag)*nco,numz);

    @ ---------------The first two sets of moment conditions.------------@
    y = deldta0[.,3];      @     w_eit             lavgwagehi_hat        @
    x = deldta0[.,4]~      @     r_hit             lrs2_hat              @
        deldta0[.,5]~      @     q_it              lplevel_hat           @
        deldta0[.,6]~      @     chi_it            lexpshare_hat         @
        deldta0[.,7];      @     m_it              lhilorat_hat          @

    b = transc(c|omega|alpha);

    u = y - x*b;

    f = z.*u;

    delta = c[1,1];
    ei = z.*(( deldta0[.,4]*(delta-1)/(delta*(alpha-1)*(omega-1)^2)).*Iomega   +
         ( deldta0[.,4]*(delta-1)/(delta*(omega-1)*(alpha-1)^2) - deldta0[.,5]/(delta*(alpha-1)^2)).*Ialpha);

    if weight == 1;
      retp(f+ei);
    elseif weight == 0;
      retp(meanc(f));
    else;
      retp(f[.,weight-1]);
    endif;

    endp;



@ ---------Subroutine for the first set of auxilliary parameters.-------------------@


proc deff2(c);
    local kappa_b, kappa_s, kappa_f, pb0, gpb, ps0, gps, pf0, gpf, pb, des,
          tee, f, u, gpl, Erh_0, phi, zeta, omega, alpha, c0, gc, n0, gn;

    kappa_b = c[1,1];
    kappa_s = c[2,1];
    kappa_f = c[3,1];
    pb0     = c[4,1];
    gpb     = c[5,1];
    ps0     = c[6,1];
    gps     = c[7,1];
    pf0     = c[8,1];
    gpf     = c[9,1];
    omega   = c[10,1];
    alpha   = c[11,1];
    gpl     = c[12,1];
    Erh_0   = c[13,1];
    phi     = c[14,1];
    zeta    = c[15,1];
    c0      = c[16,1];
    gc      = c[17,1];
    n0      = c[18,1];
    gn      = c[19,1];

    /* depreciation rates */

    f = zeros(nyr-numlag,neq);

    f[.,1] = (dbt_kbt[1:nyr-numlag] - kappa_b);
    f[.,2] = (dst_kst[1:nyr-numlag] - kappa_s);
    f[.,3] = (dft_kft[1:nyr-numlag] - kappa_f);

    /* aggregate growth rates */


    pb = ln(pbt~pst~pft);  /* the data are in levels and they need to be logged */

    tee = seqa(1,1,nyr-numlag);
    des = ones(nyr-numlag,1)~tee;
    for ii(1,3,1);
       u = pb[1:nyr-numlag,ii] - c[(ii+1)*2,1] - ln(c[(ii+1)*2+1,1])*tee;
       f[.,(ii+1)*2:(ii+1)*2+1] = des.*u;
    endfor;

    /* the more complicate aggregate growth rate */


    u = ln(Erhit[1:nyr-numlag]) - Erh_0 - ( (1-omega)*ln(gpl) + omega*ln(gps)         )*tee;
    f[.,10:11] = des.*u;


    /* the "share" parameters */

    f[.,12] = landsh_h[1:nyr-numlag] * ( (omega/(1-omega))  *(   capR/gpl - (1-kappa_f)^zeta)/(capR/gps + kappa_s - 1) + 1 ) - 1;
    f[.,13] = landsh_k[1:nyr-numlag] * ( (alpha*phi/(1-phi))*(   capR/gpl - (1-kappa_f)^zeta)/(capR/gpb + kappa_b - 1) + 1   ) - 1;


    f[.,14] = labsh_o[1:nyr-numlag] - phi*(1-alpha);
    f[.,15] = infrsh_l[1:nyr-numlag]  - zeta*(capR/gpl - (1-kappa_f)^zeta) / (capR/gpf - (1-kappa_f));



    u = ln(ct[1:nyr-numlag]) - c0 - ln(gc)*tee;
    f[.,16:17] = des.*u;

    u = pt[1:nyr-numlag] - n0 - ln(gn)*tee;
    f[.,18:19] = des.*u;

    if weight == 1;
      retp(f);
    else;
      retp(meanc(f));
    endif;

    endp;


@------------------The main GMM routine.----------------------------------@


proc (5) = minim(startval,&definef);
   local definef:proc;
   local rr, iter, ff, w, dc, gwf, f, g, obj, gwg, sqz, bvc, errflag, mm, c, nobs, lambda,
         c_new, bff, bf, bw, bg, gvc, bstderr, vc, stderr, inflnc, chisq, degf, pval;

   c = startval;
   errflag = 0;
   clear chisq;
   rr = 1;
   do until rr > rlim;

   @ ----------The program creates the weighting matrix. ----------------@
   iter = 0;
   weight = 1;
   ff = definef(c);
   nobs = rows(ff);
   weight = 0;


   if shorter == 1;
        w = newey(ff,nlag);
   else;
        if cluster == 1 and onlyerr == 0;
           w = clust(ff);
        elseif cluster == 1 and onlyerr == 1;
            w = newey(ff,nlag);
        elseif cluster == 0;
            w = newey(ff,nlag);
        endif;
   endif;

   if w == -999999;
     errflag = 1;
     retp(1,1,1,1,errflag);
     goto theend;
   endif;

        @ ----------------- Start of iteration loop --------------------------------@
   iter = 1;
   dc=1;                     @ Initialize the step length. @
   gwf=1;
   do until abs(dc) < tol;

       f=definef(c);                @ The program jumps to the subroutine that
                                  defines the f vector. @


       g=gradp(&definef,c);         @ The program jumps to the subroutine that
                                   computes analytic derivatives. The matrix
                                   of partials of f with respect to the
                                   parameters is called g. @

       obj = f'w*f;              @ This computes the value of the objective
                                   function.@

       gwg= g'w*g;               @ This uses the GAUSS-NEWTON method
                                   to compute full step dc. @
       gwf = g'w*f;

       dc = solvit(gwf,gwg);
       if scalerr(dc) > 0;
         errflag = 1;
         retp(1,1,1,1,errflag);
         goto theend;
       endif;



       if maxsqez > 0;              @ This jumps to the subroutine that
                                      adjusts the step length. @
         { c_new,sqz } = squeeze(c,dc,w,obj,&definef);
       else;
         c_new=c - dc;
       endif;


       dc=c_new-c;                     @ Update variables for the next iteration. @
       c=c_new;


      /*------------------Print out the results for the current iteration----------------
      if bb == 1;
      if floor(iter/1000) == (iter/1000);
      output off;
      "Round Number       = ";; rr;
      "Iteration Number   = ";; iter;
      "Number of Squeezes = ";; sqz;
      "Objective Function = ";; obj*nobs;

      "                                  Value           Step                Gradient";
       format /rd 14,6;
       mm=1;
       do until mm > rows(c);
        $ceename[mm,1];;"  ";; c[mm,1];; "  ";; dc[mm,1];;  "  ";@; gwf[mm,1]; @
        mm=mm+1;
        endo;

      output on;

      endif;
      endif;
      /* ----------------------End of print out of current iteration------------------*/   */

      iter=iter +1;
      if iter >= maxiter or key==27;                     @ Quit iterating if necessary. @
        goto escape;
      endif;
   endo;
   @ -------- End of iteration loop ------------------------------------------------ @
   escape:

   if rr == rlim;

   @ Compute t-ratios, etc.                                            @



           weight = 1;
             ff = definef(c);
           weight = 0;

           f = definef(c);
           if shorter == 1;
              fsavet = f;
              csavet = c;
           else;
              fsave = f;
              csave = c;
           endif;


           if shorter == 1;
                w = newey(ff,nlag);
           else;
                if cluster == 1 and onlyerr == 0;
                   w = newey(ff,nlag);
                elseif cluster == 1 and onlyerr == 1;
                   w = clust(ff);
                   lambda = invpd(clust(ff));
                elseif cluster == 0;
                   w = newey(ff,nlag);
                endif;
           endif;



           if w == -999999;
             errflag = 1;
             retp(1,1,1,1,errflag);
             goto theend;
           endif;

           g=gradp(&definef,c);

           gwg = g'w*g;


           if shorter == 1;
                 vc=invpd(gwg)/nobs;
           else;
                if cluster == 1 and onlyerr == 0;
                   vc=invpd(gwg)/nobs;
                elseif cluster == 1 and onlyerr == 1;
                   vc=invpd(gwg)*(g'w*lambda*w*g)*invpd(gwg)/nobs;
                elseif cluster == 0;
                   vc=invpd(gwg)/nobs;
                endif;
           endif;

           inflnc=-nobs*vc*g'w*ff';
           stderr=sqrt(diag(vc));
           inflnc=inflnc';

           chisq = obj*nobs;
           degf=rows(f) - rows(c);
           pval = cdfchic(chisq,degf);

     endif;
   rr = rr + 1;
   endo;

   retp(c,stderr,inflnc,chisq,errflag);

   theend:
   endp;

@ ----------------------------------------------------------------------------@
@ Subroutines to compute the clustered and Newey West weighting matrices. @


proc clust(h);
local ff,qq,hi;

    ff = 0;
    for qq(1,nco,1);
        hi = sumc(h[(qq-1)*(nyr-numlag)+1:qq*(nyr-numlag),.]);
        ff = ff + hi*hi';
    endfor;

    ff = ff/rows(h);

ff = invit(ff);
if scalerr(ff)>0;
  retp(-999999);
else;
  retp(ff);
endif;

endp;

proc newey(h,rq);
local hminus,hplus,nn,ff,qq,fyr,eyr,hi,jj;

fyr=minc(year);
eyr=maxc(year);


ff = moment(h,0)/rows(h);

for qq(1,rq,1);
     if shorter == 0;
        hplus  = selif(h,(year.>=(fyr+qq)));
        hminus = selif(h,(year.<=(eyr-qq)));
     else;
        hplus  = selif(h,(year[1:nyr-numlag].>=(fyr+qq)));
        hminus = selif(h,(year[1:nyr-numlag].<=(eyr-qq)));
     endif;
     ff = ff + (1-(qq/(rq+1)))*(hminus'hplus + hplus'hminus)/rows(hplus);
endfor;

ff = invit(ff);
if scalerr(ff)>0;
  retp(-999999);
else;
  retp(ff);
endif;


clear hplus, hminus;

endp;






@  ------------------------------------------------------------------------- @
@ Subroutine to compute squeezes.

  This subroutine compares the values of the objective function at the
  points c+s*dc and c+0.5*s*dc, with dc = the proposed change in the vector
  of parameters, and with step length s initially at 1. s is halved until
  minus the objective function stops declining.
@
proc (2) = squeeze(s_c,s_dc,w,obj,&sdeff);
local sdeff:proc;
local s_c1,s_lm,s_itr,lc1,s_c2,lc2,s_f1,s_f2;


    s_c1=s_c - s_dc; s_lm=1/2; s_itr=1;
      s_f1 = sdeff(s_c1);
    lc1 = s_f1'w*s_f1;
    clear s_f1;
  do until s_itr > maxsqez;

    s_c2=s_c-s_lm*s_dc;
      s_f2 = sdeff(s_c2);
    lc2 = s_f2'w*s_f2;
    clear s_f2;

    if lc1 <= lc2 and lc1 <= obj;

       retp(s_c1,s_itr-1); goto eoproc;

    else;

       s_c1=s_c2; s_lm=s_lm/2; lc1=lc2;
       s_itr=s_itr+1;

    endif;

  endo;
retp(s_c2,s_itr-1);

eoproc:
endp;


@-------------Subroutine to trap inversion errors----------------------@

proc invit(w);
local onemore,ww;
onemore = 1;
winv:
trap 1;
  ww = invpd(w);
trap 0;
  if scalerr(ww) > 0;
      if onemore == 1;
        call sysstate(14,1e-128);
        onemore = 0;
        goto winv;
      else;
        ww = -999999;
      endif;
  endif;

retp(ww);

endp;

@-------------Subroutine to trap solving errors----------------------@

proc solvit(a,b);
local dc,onemore;
    onemore = 1;
    solveit:
    trap 1;
    dc = solpd(a,b);
    trap 0;
    if scalerr(dc) > 0;
      if onemore == 1;
        call sysstate(14,1e-128);
        onemore = 0;
        goto solveit;
      else;
        dc = -999999;
      endif;
    endif;

retp(dc);
endp;

proc minim2(startval,&definef,&optwf);
   local definef:proc;
   local optwf:proc;
   local rr, iter, ff, w, dc, gwf, f, g, obj, gwg, sqz, bvc, errflag, mm, c, nobs, lambda,
         c_new, bff, bf, bw, bg, gvc, bstderr, vc, stderr, inflnc, chisq, degf, pval;

   c = startval;
   errflag = 0;
   clear chisq;
   rr = 1;
   do until rr > rlim;

   @ ----------The program creates the weighting matrix. ----------------@
   ff = optwf(c);


        if cluster == 1 and onlyerr == 0;
           w = clust(ff);
        elseif cluster == 1 and onlyerr == 1;
            w = newey(ff,nlag);
        elseif cluster == 0;
            w = newey(ff,nlag);
        endif;
   if w==1; "shit";end;endif;

   if w == -999999;
     errflag = 1;
     retp(errflag);
     goto theendf;
   endif;

        @ ----------------- Start of iteration loop --------------------------------@
   iter = 1;
   dc=1;                     @ Initialize the step length. @
   gwf=1;
   do until abs(dc) < tol;

       f=definef(c);                @ The program jumps to the subroutine that
                                  defines the f vector. @

       g=gradp(&definef,c);         @ The program jumps to the subroutine that
                                   computes analytic derivatives. The matrix
                                   of partials of f with respect to the
                                   parameters is called g. @

       obj = f'w*f;              @ This computes the value of the objective
                                   function.@

       gwg= g'w*g;               @ This uses the GAUSS-NEWTON method
                                   to compute full step dc. @
       gwf = g'w*f;

       dc = solvit(gwf,gwg);
       if scalerr(dc) > 0;
         errflag = 1;
         retp(errflag);
         goto theendf;
       endif;



       if maxsqez > 0;              @ This jumps to the subroutine that
                                      adjusts the step length. @
         { c_new,sqz } = squeeze(c,dc,w,obj,&definef);
       else;
         c_new=c - dc;
       endif;


       dc=c_new-c;                     @ Update variables for the next iteration. @
       c=c_new;


      /*------------------Print out the results for the current iteration---------------- */
      if floor(iter/100) == (iter/100);
      output off;
      "Round Number       = ";; rr;
      "Iteration Number   = ";; iter;
      "Number of Squeezes = ";; sqz;
      "Objective Function = ";; obj*rows(ff);

      "                                  Value           Step                Gradient";
       format /rd 14,6;
       mm=1;
       do until mm > rows(c);
     @   $ceename[mm,1];;"  ";;@ c[mm,1];; "  ";; dc[mm,1];;  "  ";@; gwf[mm,1]; @
        mm=mm+1;
        endo;

      output on;

      endif;
      /* ----------------------End of print out of current iteration------------------*/

      iter=iter +1;
      if iter >= maxiter or key==27;                     @ Quit iterating if necessary. @
        goto escape;
      endif;
   endo;
   @ -------- End of iteration loop ------------------------------------------------ @
   escape:

   if rr == rlim;

           ff = optwf(c);

           f = definef(c);
                if cluster == 1 and onlyerr == 0;
                   w = newey(ff,nlag);
                elseif cluster == 1 and onlyerr == 1;
                   w = clust(ff);
                   lambda = invpd(clust(ff));
                elseif cluster == 0;
                   w = newey(ff,nlag);
                endif;
    endif;
   rr = rr + 1;
   endo;
           retp(f'w*f*rows(ff));
   theendf:
   endp;
eop:

"Start time:  ";; timestr(ttt);
"End time:    ";; timestr(0);
"Start date:  ";; datestr(ddd);
"End date:    ";; datestr(0);

output off;
end;

